diff --git a/crypto/openssl/test/v3ext.c b/crypto/openssl/test/v3ext.c
index 88034db27155..9305a3010bf8 100644
--- a/crypto/openssl/test/v3ext.c
+++ b/crypto/openssl/test/v3ext.c
@@ -1,5 +1,5 @@
 /*
- * Copyright 2016-2022 The OpenSSL Project Authors. All Rights Reserved.
+ * Copyright 2016-2024 The OpenSSL Project Authors. All Rights Reserved.
  *
  * Licensed under the Apache License 2.0 (the "License").  You may not use
  * this file except in compliance with the License.  You can obtain a copy
@@ -269,17 +269,20 @@ static int test_addr_fam_len(void)
         goto end;
     if (!ASN1_OCTET_STRING_set(f1->addressFamily, key, keylen))
         goto end;
+
+    /* Push and transfer memory ownership to stack */
     if (!sk_IPAddressFamily_push(addr, f1))
         goto end;
+    f1 = NULL;
 
     /* Shouldn't be able to canonize this as the len is > 3*/
     if (!TEST_false(X509v3_addr_canonize(addr)))
         goto end;
 
-    /* Create a well formed IPAddressFamily */
-    f1 = sk_IPAddressFamily_pop(addr);
-    IPAddressFamily_free(f1);
+    /* Pop and free the new stack element */
+    IPAddressFamily_free(sk_IPAddressFamily_pop(addr));
 
+    /* Create a well-formed IPAddressFamily */
     key[0] = (afi >> 8) & 0xFF;
     key[1] = afi & 0xFF;
     key[2] = 0x1;
@@ -297,8 +300,11 @@ static int test_addr_fam_len(void)
 
     /* Mark this as inheritance so we skip some of the is_canonize checks */
     f1->ipAddressChoice->type = IPAddressChoice_inherit;
+
+    /* Push and transfer memory ownership to stack */
     if (!sk_IPAddressFamily_push(addr, f1))
         goto end;
+    f1 = NULL;
 
     /* Should be able to canonize now */
     if (!TEST_true(X509v3_addr_canonize(addr)))
@@ -306,7 +312,10 @@ static int test_addr_fam_len(void)
 
     testresult = 1;
   end:
+    /* Free stack and any memory owned by detached element */
+    IPAddressFamily_free(f1);
     sk_IPAddressFamily_pop_free(addr, IPAddressFamily_free);
+
     ASN1_OCTET_STRING_free(ip1);
     ASN1_OCTET_STRING_free(ip2);
     return testresult;
diff --git a/etc/Makefile b/etc/Makefile
index ddef82f64510..bd6d692e5316 100644
--- a/etc/Makefile
+++ b/etc/Makefile
@@ -88,10 +88,6 @@ distribution:
 .if ${MK_SENDMAIL} != "no"
 	cd ${.CURDIR}/mail; ${INSTALL} -o ${BINOWN} -g ${BINGRP} -m 644 \
 		-T "package=sendmail" ${ETCMAIL_SENDMAIL} ${DESTDIR}/etc/mail
-.endif
-.if ${MK_LOCATE} != "no"
-	${INSTALL} -o nobody -g ${BINGRP} -m 644 -T "package=runtime"\
-	    /dev/null ${DESTDIR}/var/db/locate.database
 .endif
 	cd ${.CURDIR}/..; ${INSTALL} -o ${BINOWN} -g ${BINGRP} -m 444 \
 		-T "package=runtime" ${FREEBSD} ${DESTDIR}/
diff --git a/lib/clang/include/VCSVersion.inc b/lib/clang/include/VCSVersion.inc
index c4bb0df4e3a5..941c98e43c9a 100644
--- a/lib/clang/include/VCSVersion.inc
+++ b/lib/clang/include/VCSVersion.inc
@@ -1,8 +1,8 @@
-#define LLVM_REVISION "llvmorg-18.1.5-0-g617a15a9eac9"
+#define LLVM_REVISION "llvmorg-18.1.6-0-g1118c2e05e67"
 #define LLVM_REPOSITORY "https://github.com/llvm/llvm-project.git"
 
-#define CLANG_REVISION "llvmorg-18.1.5-0-g617a15a9eac9"
+#define CLANG_REVISION "llvmorg-18.1.6-0-g1118c2e05e67"
 #define CLANG_REPOSITORY "https://github.com/llvm/llvm-project.git"
 
-#define LLDB_REVISION "llvmorg-18.1.5-0-g617a15a9eac9"
+#define LLDB_REVISION "llvmorg-18.1.6-0-g1118c2e05e67"
 #define LLDB_REPOSITORY "https://github.com/llvm/llvm-project.git"
diff --git a/lib/clang/include/clang/Basic/Version.inc b/lib/clang/include/clang/Basic/Version.inc
index c243016c5f73..405ee341dfcd 100644
--- a/lib/clang/include/clang/Basic/Version.inc
+++ b/lib/clang/include/clang/Basic/Version.inc
@@ -1,8 +1,8 @@
-#define	CLANG_VERSION			18.1.5
-#define	CLANG_VERSION_STRING		"18.1.5"
+#define	CLANG_VERSION			18.1.6
+#define	CLANG_VERSION_STRING		"18.1.6"
 #define	CLANG_VERSION_MAJOR		18
 #define	CLANG_VERSION_MAJOR_STRING	"18"
 #define	CLANG_VERSION_MINOR		1
-#define	CLANG_VERSION_PATCHLEVEL	5
+#define	CLANG_VERSION_PATCHLEVEL	6
 
 #define	CLANG_VENDOR			"FreeBSD "
diff --git a/lib/clang/include/lld/Common/Version.inc b/lib/clang/include/lld/Common/Version.inc
index 4079a361ce8d..20f5fbe6e124 100644
--- a/lib/clang/include/lld/Common/Version.inc
+++ b/lib/clang/include/lld/Common/Version.inc
@@ -1,4 +1,4 @@
 // Local identifier in __FreeBSD_version style
 #define LLD_FREEBSD_VERSION 1400006
 
-#define LLD_VERSION_STRING "18.1.5 (FreeBSD llvmorg-18.1.5-0-g617a15a9eac9-" __XSTRING(LLD_FREEBSD_VERSION) ")"
+#define LLD_VERSION_STRING "18.1.6 (FreeBSD llvmorg-18.1.6-0-g1118c2e05e67-" __XSTRING(LLD_FREEBSD_VERSION) ")"
diff --git a/lib/clang/include/lldb/Version/Version.inc b/lib/clang/include/lldb/Version/Version.inc
index 0e86bd2e01ba..c693f099ccff 100644
--- a/lib/clang/include/lldb/Version/Version.inc
+++ b/lib/clang/include/lldb/Version/Version.inc
@@ -1,6 +1,6 @@
-#define LLDB_VERSION 18.1.5
-#define LLDB_VERSION_STRING "18.1.5"
+#define LLDB_VERSION 18.1.6
+#define LLDB_VERSION_STRING "18.1.6"
 #define LLDB_VERSION_MAJOR 18
 #define LLDB_VERSION_MINOR 1
-#define LLDB_VERSION_PATCH 5
+#define LLDB_VERSION_PATCH 6
 /* #undef LLDB_FULL_VERSION_STRING */
diff --git a/lib/clang/include/llvm/Config/config.h b/lib/clang/include/llvm/Config/config.h
index 0760c0b17a87..65e903427a83 100644
--- a/lib/clang/include/llvm/Config/config.h
+++ b/lib/clang/include/llvm/Config/config.h
@@ -344,10 +344,10 @@
 #define PACKAGE_NAME "LLVM"
 
 /* Define to the full name and version of this package. */
-#define PACKAGE_STRING "LLVM 18.1.5"
+#define PACKAGE_STRING "LLVM 18.1.6"
 
 /* Define to the version of this package. */
-#define PACKAGE_VERSION "18.1.5"
+#define PACKAGE_VERSION "18.1.6"
 
 /* Define to the vendor of this package. */
 /* #undef PACKAGE_VENDOR */
diff --git a/lib/clang/include/llvm/Config/llvm-config.h b/lib/clang/include/llvm/Config/llvm-config.h
index 049529efdd7f..372a69017f79 100644
--- a/lib/clang/include/llvm/Config/llvm-config.h
+++ b/lib/clang/include/llvm/Config/llvm-config.h
@@ -176,10 +176,10 @@
 #define LLVM_VERSION_MINOR 1
 
 /* Patch version of the LLVM API */
-#define LLVM_VERSION_PATCH 5
+#define LLVM_VERSION_PATCH 6
 
 /* LLVM version string */
-#define LLVM_VERSION_STRING "18.1.5"
+#define LLVM_VERSION_STRING "18.1.6"
 
 /* Whether LLVM records statistics for use with GetStatistics(),
  * PrintStatistics() or PrintStatisticsJSON()
diff --git a/lib/clang/include/llvm/Support/VCSRevision.h b/lib/clang/include/llvm/Support/VCSRevision.h
index 433b2b53b8fe..9c8ecebe02de 100644
--- a/lib/clang/include/llvm/Support/VCSRevision.h
+++ b/lib/clang/include/llvm/Support/VCSRevision.h
@@ -1,2 +1,2 @@
-#define LLVM_REVISION "llvmorg-18.1.5-0-g617a15a9eac9"
+#define LLVM_REVISION "llvmorg-18.1.6-0-g1118c2e05e67"
 #define LLVM_REPOSITORY "https://github.com/llvm/llvm-project.git"
diff --git a/lib/libarchive/Makefile.inc b/lib/libarchive/Makefile.inc
index 153f96b12165..755a39ec01e8 100644
--- a/lib/libarchive/Makefile.inc
+++ b/lib/libarchive/Makefile.inc
@@ -4,7 +4,8 @@
 
 LIBADD=	z bz2 lzma bsdxml zstd
 CFLAGS+=	-DHAVE_BZLIB_H=1 -DHAVE_LIBLZMA=1 -DHAVE_LZMA_H=1 \
-		-DHAVE_ZSTD_H=1 -DHAVE_LIBZSTD=1 -DHAVE_ZSTD_compressStream=1
+		-DHAVE_ZSTD_H=1 -DHAVE_LIBZSTD=1 -DHAVE_ZSTD_compressStream=1 \
+		-DHAVE_SYSCONF=1
 CFLAGS+=	-DPLATFORM_CONFIG_H=\"${.CURDIR}/config_freebsd.h\"
 
 .if ${MK_OPENSSL} != "no"
diff --git a/lib/libcapsicum/capsicum_helpers.h b/lib/libcapsicum/capsicum_helpers.h
index f137ec1806f9..a6c696aa9a8e 100644
--- a/lib/libcapsicum/capsicum_helpers.h
+++ b/lib/libcapsicum/capsicum_helpers.h
@@ -133,8 +133,17 @@ caph_limit_stdio(void)
 static __inline void
 caph_cache_tzdata(void)
 {
+	time_t delta;
 
 	tzset();
+
+	/*
+	 * The tzset() function does not cache all time zones.
+	 * Some functions, such as gmtime(), require a GMT time zone.
+	 * The only way to cache them is to call the function directly.
+	 */
+	delta = 0;
+	(void)gmtime(&delta);
 }
 
 static __inline void
diff --git a/lib/libcompat/Makefile b/lib/libcompat/Makefile
index 7c99556e7513..e30e120c3d41 100644
--- a/lib/libcompat/Makefile
+++ b/lib/libcompat/Makefile
@@ -7,12 +7,7 @@ NO_PIC=
 
 WARNS?=	0
 
-.PATH:	${.CURDIR}/4.1 ${.CURDIR}/4.3 ${.CURDIR}/4.4
-
-# compat 4.1 sources
-SRCS+=	ftime.c
-
-MAN+=	4.1/ftime.3
+.PATH:	${.CURDIR}/4.3 ${.CURDIR}/4.4
 
 # compat 4.3 sources
 SRCS+=	re_comp.c rexec.c
diff --git a/lib/libpam/modules/pam_xdg/pam_xdg.c b/lib/libpam/modules/pam_xdg/pam_xdg.c
index 4d586a21566a..2c80f0a0332f 100644
--- a/lib/libpam/modules/pam_xdg/pam_xdg.c
+++ b/lib/libpam/modules/pam_xdg/pam_xdg.c
@@ -67,7 +67,7 @@ _pam_xdg_open(pam_handle_t *pamh, int flags __unused,
 
 	/* Get user info */
 	rv = pam_get_item(pamh, PAM_USER, (const void **)&user);
-	if (rv != PAM_SUCCESS) {
+	if (rv != PAM_SUCCESS || user == NULL) {
 		PAM_VERBOSE_ERROR("Can't get user information");
 		goto out;
 	}
@@ -221,7 +221,7 @@ _pam_xdg_close(pam_handle_t *pamh __unused, int flags __unused,
 
 	/* Get user info */
 	rv = pam_get_item(pamh, PAM_USER, (const void **)&user);
-	if (rv != PAM_SUCCESS) {
+	if (rv != PAM_SUCCESS || user == NULL) {
 		PAM_VERBOSE_ERROR("Can't get user information");
 		goto out;
 	}
diff --git a/lib/libusbhid/usbhid.h b/lib/libusbhid/usbhid.h
index 15d4f1613746..637fb3d846f7 100644
--- a/lib/libusbhid/usbhid.h
+++ b/lib/libusbhid/usbhid.h
@@ -29,6 +29,9 @@
  *
  */
 
+#ifndef _USBHID_H_
+#define _USBHID_H_
+
 #include <stdint.h>
 
 typedef struct report_desc *report_desc_t;
@@ -111,3 +114,5 @@ int hid_set_report(int fd, enum hid_kind k,
     unsigned char *data, unsigned int size);
 
 __END_DECLS
+
+#endif /* !_USBHID_H_ */
diff --git a/lib/libutil/Makefile b/lib/libutil/Makefile
index 889a81747c82..5bce5c158958 100644
--- a/lib/libutil/Makefile
+++ b/lib/libutil/Makefile
@@ -12,7 +12,7 @@ LIB=	util
 SHLIB_MAJOR= 9
 
 SRCS=	_secure_path.c auth.c cpuset.c expand_number.c flopen.c fparseln.c \
-	getlocalbase.c  gr_util.c \
+	ftime.c getlocalbase.c gr_util.c \
 	hexdump.c humanize_number.c kinfo_getfile.c \
 	kinfo_getallproc.c kinfo_getproc.c kinfo_getvmmap.c \
 	kinfo_getvmobject.c kld.c \
@@ -30,8 +30,8 @@ CFLAGS+= -DINET6
 
 CFLAGS+= -I${.CURDIR} -I${SRCTOP}/lib/libc/gen/
 
-MAN+=	cpuset.3 expand_number.3 flopen.3 fparseln.3 getlocalbase.3 hexdump.3 \
-	humanize_number.3 kinfo_getallproc.3 kinfo_getfile.3 \
+MAN+=	cpuset.3 expand_number.3 flopen.3 fparseln.3 ftime.3 getlocalbase.3 \
+	hexdump.3 humanize_number.3 kinfo_getallproc.3 kinfo_getfile.3 \
 	kinfo_getproc.3 kinfo_getvmmap.3 kinfo_getvmobject.3 kld.3 \
 	login_auth.3 login_cap.3 \
 	login_class.3 login_ok.3 login_times.3 login_tty.3 pidfile.3 \
diff --git a/lib/libcompat/4.1/ftime.c b/lib/libutil/ftime.c
similarity index 99%
rename from lib/libcompat/4.1/ftime.c
rename to lib/libutil/ftime.c
index 5ea57bca40fd..b31fca907883 100644
--- a/lib/libcompat/4.1/ftime.c
+++ b/lib/libutil/ftime.c
@@ -33,6 +33,8 @@
 #include <sys/cdefs.h>
 #include <sys/types.h>
 #include <sys/time.h>
+
+#define _IN_LIBUITL
 #include <sys/timeb.h>
 
 int
diff --git a/lib/ncurses/config.mk b/lib/ncurses/config.mk
index 8a3e7d0ffa59..50f333a547c9 100644
--- a/lib/ncurses/config.mk
+++ b/lib/ncurses/config.mk
@@ -3,8 +3,8 @@
 
 NCURSES_DIR=	${SRCTOP}/contrib/ncurses
 NCURSES_MAJOR=	6
-NCURSES_MINOR=	2
-NCURSES_PATCH=	20210220
+NCURSES_MINOR=	5
+NCURSES_PATCH=	20240407
 
 TINFO_OBJDIR?=	${.OBJDIR:H}/tinfo
 
diff --git a/lib/ncurses/tinfo/Makefile b/lib/ncurses/tinfo/Makefile
index c1ea75d3aacd..b202a40a1cc3 100644
--- a/lib/ncurses/tinfo/Makefile
+++ b/lib/ncurses/tinfo/Makefile
@@ -54,6 +54,8 @@ HAVE_TERMIO_H=		0
 HAVE_VSSCANF=		1
 HAVE_STDINT_H=		1
 HEADER_STDBOOL=		1
+HAVE_STDNORETURN_H=	0
+ENABLE_SIGWINCH=	1
 # XXX amd64 1L and int
 ONEUL=			1U
 TYPEOF_CHTYPE=		uint32_t
@@ -332,6 +334,7 @@ curses.head: curses.h.in
 	    -e "/@BROKEN_LINKER@/s%%${BROKEN_LINKER}%" \
 	    -e "/@HAVE_VSSCANF@/s%%${HAVE_VSSCANF}%" \
 	    -e "/@HAVE_STDINT_H@/s%%${HAVE_STDINT_H}%" \
+	    -e "/@HAVE_STDNORETURN_H@/s%%${HAVE_STDNORETURN_H}%" \
 	    -e "/@NCURSES_CH_T@/s%%${NCURSES_CH_T}%" \
 	    -e "/@NCURSES_CONST@/s%%${NCURSES_CONST}%" \
 	    -e "/@NCURSES_EXT_COLORS@/s%%${NCURSES_EXT_COLORS}%" \
@@ -342,6 +345,7 @@ curses.head: curses.h.in
 	    -e "/@NCURSES_MBSTATE_T@/s%%${NCURSES_MBSTATE_T}%" \
 	    -e "/@NCURSES_MINOR@/s%%${NCURSES_MINOR}%" \
 	    -e "/@NCURSES_MOUSE_VERSION@/s%%${NCURSES_MOUSE_VERSION}%" \
+	    -e "/@NCURSES_XNAMES@/s%%${NCURSES_XNAMES}%" \
 	    -e "/@NCURSES_OK_WCHAR_T@/s%%${NCURSES_OK_WCHAR_T}%" \
 	    -e "/@NCURSES_OPAQUE@/s%%${NCURSES_OPAQUE}%" \
 	    -e "/@NCURSES_OPAQUE_FORM@/s%%${NCURSES_OPAQUE_FORM}%" \
@@ -367,6 +371,7 @@ curses.head: curses.h.in
 	    -e "s%@cf_cv_enable_lp64@%${ENABLE_LP64}%g" \
 	    -e "s%@cf_cv_enable_opaque@%${ENABLE_OPAQUE}%g" \
 	    -e "s%@cf_cv_enable_reentrant@%${ENABLE_REENTRANT}%g" \
+	    -e "s%@cf_cv_enable_sigwinch@%${ENABLE_SIGWINCH}%g" \
 	    -e "s%@cf_cv_header_stdbool_h@%${HEADER_STDBOOL}%g" \
 	    -e "s%@cf_cv_type_of_bool@%${TYPE_OF_BOOL}%g" \
 	    -e "s%@cf_cv_typeof_chtype@%${TYPEOF_CHTYPE}%g" \
diff --git a/lib/ncurses/tinfo/ncurses_cfg.h b/lib/ncurses/tinfo/ncurses_cfg.h
index 556938aaa586..33890f300310 100644
--- a/lib/ncurses/tinfo/ncurses_cfg.h
+++ b/lib/ncurses/tinfo/ncurses_cfg.h
@@ -47,35 +47,47 @@
  *	https://invisible-island.net/autoconf/
  *	ftp://ftp.invisible-island.net/autoconf/
  */
-
-
 #ifndef NC_CONFIG_H
 #define NC_CONFIG_H
 
 #define PACKAGE "ncurses"
-#define NCURSES_VERSION "6.2"
-#define NCURSES_PATCHDATE 20210220
+#define NCURSES_VERSION "6.5"
+#define NCURSES_PATCHDATE 20240427
 #define SYSTEM_NAME "FreeBSD"
 #if 0
 #include <stdlib.h>
 #endif
 #define HAVE_LONG_FILE_NAMES 1
 #define MIXEDCASE_FILENAMES 1
-#ifdef __FreeBSD__
+#define STDC_HEADERS 1
+#define USE_GETCAP 1
+#define USE_BSD_TPUTS 1
+#define HAVE_BSD_CGETENT 1
+#define HAVE_SYS_TYPES_H 1
+#define HAVE_SYS_STAT_H 1
+#define HAVE_STDLIB_H 1
+#define HAVE_STRING_H 1
+#define HAVE_MEMORY_H 1
+#define HAVE_STRINGS_H 1
+#define HAVE_INTTYPES_H 1
+#define HAVE_STDINT_H 1
+#define HAVE_UNISTD_H 1
+#define HAVE_DIRENT_H 1
 #define USE_SYSMOUSE 1
-#endif
 #define TERMINFO_DIRS "/usr/share/terminfo:/usr/local/share/terminfo:/usr/local/share/site-terminfo"
 #define TERMINFO "/usr/share/terminfo"
 #define HAVE_BIG_CORE 1
 #define TERMPATH "/etc/termcap:/usr/share/misc/termcap"
-#define USE_GETCAP 1
+#define USE_HOME_TERMINFO 1
+#define USE_ROOT_ENVIRON 1
+#define USE_ROOT_ACCESS 1
+#define USE_SETUID_ENVIRON 1
 #define HAVE_UNISTD_H 1
 #define HAVE_REMOVE 1
 #define HAVE_UNLINK 1
 #define HAVE_LINK 1
 #define HAVE_SYMLINK 1
 #define USE_LINKS 1
-#define BSD_TPUTS 1
 #define HAVE_LANGINFO_CODESET 1
 #define USE_WIDEC_SUPPORT 1
 #define NCURSES_WIDECHAR 1
@@ -84,6 +96,7 @@
 #define HAVE_PUTWC 1
 #define HAVE_BTOWC 1
 #define HAVE_WCTOB 1
+#define HAVE_WMEMCHR 1
 #define HAVE_MBTOWC 1
 #define HAVE_WCTOMB 1
 #define HAVE_MBLEN 1
@@ -95,16 +108,7 @@
 #define HAVE_MBSTOWCS 1
 #define NEED_WCHAR_H 1
 #define HAVE_FSEEKO 1
-#define STDC_HEADERS 1
-#define HAVE_SYS_TYPES_H 1
-#define HAVE_SYS_STAT_H 1
-#define HAVE_STDLIB_H 1
-#define HAVE_STRING_H 1
-#define HAVE_MEMORY_H 1
-#define HAVE_STRINGS_H 1
-#define HAVE_INTTYPES_H 1
-#define HAVE_STDINT_H 1
-#define HAVE_UNISTD_H 1
+#define RGB_PATH "no"
 #define SIZEOF_SIGNED_CHAR 1
 #define NCURSES_EXT_FUNCS 1
 #define HAVE_ASSUME_DEFAULT_COLORS 1
@@ -114,7 +118,6 @@
 #define HAVE_RESIZE_TERM 1
 #define HAVE_TERM_ENTRY_H 1
 #define HAVE_USE_DEFAULT_COLORS 1
-#define HAVE_USE_EXTENDED_NAMES 1
 #define HAVE_USE_SCREEN 1
 #define HAVE_USE_WINDOW 1
 #define HAVE_WRESIZE 1
@@ -127,10 +130,10 @@
 #define NCURSES_EXT_PUTWIN 1
 #define NCURSES_NO_PADDING 1
 #define USE_SIGWINCH 1
+#define NCURSES_XNAMES 1
 #define NCURSES_WRAP_PREFIX "_nc_"
 #define USE_ASSUMED_COLOR 1
 #define USE_HASHMAP 1
-#define USE_COLORFGBG 1
 #define GCC_SCANF 1
 #define GCC_SCANFLIKE(fmt,var) __attribute__((format(scanf,fmt,var)))
 #define GCC_PRINTF 1
@@ -138,9 +141,7 @@
 #define GCC_UNUSED __attribute__((unused))
 #define GCC_NORETURN __attribute__((noreturn))
 #define HAVE_NC_ALLOC_H 1
-#define HAVE_GETTIMEOFDAY 1
-#define STDC_HEADERS 1
-#define HAVE_DIRENT_H 1
+#define HAVE_MATH_FUNCS 1
 #define TIME_WITH_SYS_TIME 1
 #define HAVE_REGEX_H_FUNCS 1
 #define HAVE_FCNTL_H 1
@@ -149,13 +150,13 @@
 #define HAVE_LOCALE_H 1
 #define HAVE_MATH_H 1
 #define HAVE_POLL_H 1
+#define HAVE_SYS_AUXV_H 1
 #define HAVE_SYS_IOCTL_H 1
 #define HAVE_SYS_PARAM_H 1
 #define HAVE_SYS_POLL_H 1
 #define HAVE_SYS_SELECT_H 1
 #define HAVE_SYS_TIME_H 1
 #define HAVE_SYS_TIMES_H 1
-#define HAVE_TTYENT_H 1
 #define HAVE_UNISTD_H 1
 #define HAVE_WCTYPE_H 1
 #define HAVE_UNISTD_H 1
@@ -169,20 +170,20 @@
 #define HAVE_SYS_TIME_SELECT 1
 #define SIG_ATOMIC_T volatile sig_atomic_t
 #define HAVE_ERRNO 1
+#define HAVE_CLOCK_GETTIME 1
+#define HAVE_FPATHCONF 1
 #define HAVE_GETCWD 1
 #define HAVE_GETEGID 1
 #define HAVE_GETEUID 1
 #define HAVE_GETOPT 1
-#define HAVE_GETTTYNAM 1
+#define HAVE_GETUID 1
 #define HAVE_ISSETUGID 1
 #define HAVE_LOCALECONV 1
 #define HAVE_POLL 1
-#define HAVE_PUTENV 1
 #define HAVE_REMOVE 1
 #define HAVE_SELECT 1
 #define HAVE_SETBUF 1
 #define HAVE_SETBUFFER 1
-#define HAVE_SETENV 1
 #define HAVE_SETVBUF 1
 #define HAVE_SIGACTION 1
 #define HAVE_SIGVEC 1
@@ -194,7 +195,8 @@
 #define HAVE_TIMES 1
 #define HAVE_TSEARCH 1
 #define HAVE_VSNPRINTF 1
-#define HAVE_BSD_CGETENT 1
+#define HAVE_PATH_TTYS 1
+#define HAVE_GETTTYNAM 1
 #define HAVE_ISASCII 1
 #define HAVE_NANOSLEEP 1
 #define HAVE_TERMIOS_H 1
@@ -206,6 +208,7 @@
 #define HAVE_MKSTEMP 1
 #define HAVE_SIZECHANGE 1
 #define HAVE_WORKING_POLL 1
+#define HAVE_CONSISTENT_MB_LEN_MAX 1
 #define HAVE_VA_COPY 1
 #define HAVE_UNISTD_H 1
 #define HAVE_FORK 1
@@ -219,6 +222,7 @@
 #define HAVE_IOSTREAM 1
 #define IOSTREAM_NAMESPACE 1
 #define SIZEOF_BOOL 1
+#define CPP_HAS_OVERRIDE 1
 #define CPP_HAS_STATIC_CAST 1
 #define SIZEOF_WCHAR_T 4
 #define HAVE_SLK_COLOR 1
@@ -229,9 +233,8 @@
 #define HAVE_FORM_H 1
 #define HAVE_LIBFORM 1
 #define NCURSES_PATHSEP ':'
-#define NCURSES_VERSION_STRING "6.2.20210220"
+#define NCURSES_VERSION_STRING "6.5.20240427"
 #define NCURSES_OSPEED_COMPAT 1
-#define HAVE_CURSES_DATA_BOOLNAMES 1
 
 #include <ncurses_def.h>
 
diff --git a/libexec/nuageinit/nuage.lua b/libexec/nuageinit/nuage.lua
index 55486ae2b122..ca70c778791b 100644
--- a/libexec/nuageinit/nuage.lua
+++ b/libexec/nuageinit/nuage.lua
@@ -72,7 +72,12 @@ local function adduser(pwd)
 		warnmsg("Argument should be a table")
 		return nil
 	end
-	local f = io.popen("getent passwd "..pwd.name)
+	local root = os.getenv("NUAGE_FAKE_ROOTDIR")
+	local cmd = "pw "
+	if root then
+		cmd = cmd .. "-R " .. root .. " "
+	end
+	local f = io.popen(cmd .. " usershow " ..pwd.name .. " -7 2>/dev/null")
 	local pwdstr = f:read("*a")
 	f:close()
 	if pwdstr:len() ~= 0 then
@@ -109,8 +114,7 @@ local function adduser(pwd)
 		precmd = "echo "..pwd.plain_text_passwd .. "| "
 		postcmd = " -H 0 "
 	end
-	local root = os.getenv("NUAGE_FAKE_ROOTDIR")
-	local cmd = precmd .. "pw "
+	cmd = precmd .. "pw "
 	if root then
 		cmd = cmd .. "-R " .. root .. " "
 	end
@@ -140,7 +144,12 @@ local function addgroup(grp)
 		warnmsg("Argument should be a table")
 		return false
 	end
-	local f = io.popen("getent group "..grp.name)
+	local root = os.getenv("NUAGE_FAKE_ROOTDIR")
+	local cmd = "pw "
+	if root then
+		cmd = cmd .. "-R " .. root .. " "
+	end
+	local f = io.popen(cmd .. " groupshow " ..grp.name .. " 2>/dev/null")
 	local grpstr = f:read("*a")
 	f:close()
 	if grpstr:len() ~= 0 then
@@ -151,8 +160,7 @@ local function addgroup(grp)
 		local list = splitlist(grp.members)
 		extraargs = " -M " .. table.concat(list, ',')
 	end
-	local root = os.getenv("NUAGE_FAKE_ROOTDIR")
-	local cmd = "pw "
+	cmd = "pw "
 	if root then
 		cmd = cmd .. "-R " .. root .. " "
 	end
@@ -169,6 +177,10 @@ end
 local function addsshkey(homedir, key)
 	local chownak = false
 	local chowndotssh = false
+	local root = os.getenv("NUAGE_FAKE_ROOTDIR")
+	if root then
+		homedir = root .. "/" .. homedir
+	end
 	local ak_path = homedir .. "/.ssh/authorized_keys"
 	local dotssh_path = homedir .. "/.ssh"
 	local dirattrs = lfs.attributes(ak_path)
diff --git a/libexec/rc/rc.conf b/libexec/rc/rc.conf
index 7f9e67981eec..a7b149bb0cd4 100644
--- a/libexec/rc/rc.conf
+++ b/libexec/rc/rc.conf
@@ -61,8 +61,8 @@ varmfs_flags="-S"	# Extra mount options for the mfs /var
 mfs_type="auto"		# "md", "tmpfs", "auto" to prefer tmpfs with md as fallback
 populate_var="AUTO"	# Set to YES to always (re)populate /var, NO to never
 cleanvar_enable="YES" 	# Clean the /var directory
-var_run_enable="NO" 	# Save/restore /var/run structure at shutdown/reboot
-var_run_autosave="NO" 	# Only restore /var/run structure at shutdown/reboot
+var_run_enable="YES" 	# Save/restore /var/run structure at shutdown/reboot
+var_run_autosave="YES" 	# Only restore /var/run structure at shutdown/reboot
 			# The user is expected to issue service var_run save to
 			# manually save the /var/run mtree
 var_run_mtree="/var/db/mtree/BSD.var-run.mtree"
diff --git a/libexec/rc/rc.d/devd b/libexec/rc/rc.d/devd
index 43fb9d5928dd..fe19abd817b4 100755
--- a/libexec/rc/rc.d/devd
+++ b/libexec/rc/rc.d/devd
@@ -14,7 +14,8 @@ desc="Device state change daemon"
 rcvar="devd_enable"
 command="/sbin/${name}"
 
-start_precmd=${name}_prestart
+devd_offcmd=devd_off
+start_precmd=find_pidfile
 stop_precmd=find_pidfile
 
 find_pidfile()
@@ -26,10 +27,8 @@ find_pidfile()
 	fi
 }
 
-devd_prestart()
+devd_off()
 {
-	find_pidfile
-
 	# If devd is disabled, turn it off in the kernel to avoid unnecessary
 	# memory usage.
 	if ! checkyesno ${rcvar}; then
diff --git a/libexec/rc/rc.d/var_run b/libexec/rc/rc.d/var_run
index daff06ce1a3f..bf8f0cb737b4 100755
--- a/libexec/rc/rc.d/var_run
+++ b/libexec/rc/rc.d/var_run
@@ -17,11 +17,6 @@ stop_cmd="_var_run_stop"
 
 load_rc_config $name
 
-# Set defaults
-: ${var_run_enable:="NO"}
-: ${var_run_mtree:="/var/db/mtree/BSD.var-run.mtree"}
-: ${var_run_autosave:="YES"}
-
 _var_run_load() {
 	test -f ${var_run_mtree} &&
 		mtree -U -i -q -f ${var_run_mtree} -p /var/run > /dev/null
diff --git a/libexec/rc/rc.subr b/libexec/rc/rc.subr
index 332718dc6f2c..05d46f74e598 100644
--- a/libexec/rc/rc.subr
+++ b/libexec/rc/rc.subr
@@ -816,6 +816,9 @@ startmsg()
 #
 #	${name}_limits	n	limits(1) to apply to ${command}.
 #
+#	${name}_offcmd	n	If set, run during start
+#				if a service is not enabled.
+#
 #	${rc_arg}_cmd	n	If set, use this as the method when invoked;
 #				Otherwise, use default command (see below)
 #
@@ -1051,13 +1054,13 @@ run_rc_command()
 		    -a "$rc_arg" != "describe" -a "$rc_arg" != "status" ] ||
 		    [ -n "${rcvar}" -a "$rc_arg" = "stop" -a -z "${rc_pid}" ]; then
 			if ! checkyesno ${rcvar}; then
-				if [ -n "${rc_quiet}" ]; then
-					return 0
-				fi
+			    [ "$rc_arg" = "start" ] && _run_rc_offcmd
+			    if [ -z "${rc_quiet}" ]; then
 				echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
 				echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
 				echo "instead of '${rc_arg}'."
-				return 0
+			    fi
+			    return 0
 			fi
 		fi
 
@@ -1347,10 +1350,25 @@ $_cpusetcmd $command $rc_flags $command_args"
 #
 #	name	       R/W
 #	------------------
+#	_offcmd		R
 #	_precmd		R
 #	_postcmd	R
 #	_return		W
 #
+_run_rc_offcmd()
+{
+	eval _offcmd=\$${name}_offcmd
+	if [ -n "$_offcmd" ]; then
+		if [ -n "$_env" ]; then
+			eval "export -- $_env"
+		fi
+		debug "run_rc_command: ${name}_offcmd: $_offcmd $rc_extra_args"
+		eval "$_offcmd $rc_extra_args"
+		_return=$?
+	fi
+	return 0
+}
+
 _run_rc_precmd()
 {
 	check_required_before "$rc_arg" || return 1
diff --git a/libexec/tftpd/tftpd.c b/libexec/tftpd/tftpd.c
index 00c1257ce548..cef8d0278a55 100644
--- a/libexec/tftpd/tftpd.c
+++ b/libexec/tftpd/tftpd.c
@@ -692,28 +692,27 @@ find_next_name(char *filename, int *fd)
 int
 validate_access(int peer, char **filep, int mode)
 {
-	struct stat stbuf;
-	int	fd;
-	int	error;
-	struct dirlist *dirp;
 	static char pathname[MAXPATHLEN];
+	struct stat sb;
+	struct dirlist *dirp;
 	char *filename = *filep;
+	int	err, fd;
 
 	/*
 	 * Prevent tricksters from getting around the directory restrictions
 	 */
-	if (strstr(filename, "/../"))
+	if (strncmp(filename, "../", 3) == 0 ||
+	    strstr(filename, "/../") != NULL)
 		return (EACCESS);
 
 	if (*filename == '/') {
 		/*
-		 * Allow the request if it's in one of the approved locations.
-		 * Special case: check the null prefix ("/") by looking
-		 * for length = 1 and relying on the arg. processing that
-		 * it's a /.
+		 * Absolute file name: allow the request if it's in one of the
+		 * approved locations.
 		 */
 		for (dirp = dirs; dirp->name != NULL; dirp++) {
 			if (dirp->len == 1)
+				/* Only "/" can have len 1 */
 				break;
 			if (strncmp(filename, dirp->name, dirp->len) == 0 &&
 			    filename[dirp->len] == '/')
@@ -722,30 +721,20 @@ validate_access(int peer, char **filep, int mode)
 		/* If directory list is empty, allow access to any file */
 		if (dirp->name == NULL && dirp != dirs)
 			return (EACCESS);
-		if (stat(filename, &stbuf) < 0)
+		if (stat(filename, &sb) != 0)
 			return (errno == ENOENT ? ENOTFOUND : EACCESS);
-		if ((stbuf.st_mode & S_IFMT) != S_IFREG)
+		if (!S_ISREG(sb.st_mode))
 			return (ENOTFOUND);
 		if (mode == RRQ) {
-			if ((stbuf.st_mode & S_IROTH) == 0)
+			if ((sb.st_mode & S_IROTH) == 0)
 				return (EACCESS);
 		} else {
-			if (check_woth && ((stbuf.st_mode & S_IWOTH) == 0))
+			if (check_woth && (sb.st_mode & S_IWOTH) == 0)
 				return (EACCESS);
 		}
 	} else {
-		int err;
-
 		/*
 		 * Relative file name: search the approved locations for it.
-		 * Don't allow write requests that avoid directory
-		 * restrictions.
-		 */
-
-		if (!strncmp(filename, "../", 3))
-			return (EACCESS);
-
-		/*
 		 * If the file exists in one of the directories and isn't
 		 * readable, continue looking. However, change the error code
 		 * to give an indication that the file exists.
@@ -753,18 +742,20 @@ validate_access(int peer, char **filep, int mode)
 		err = ENOTFOUND;
 		for (dirp = dirs; dirp->name != NULL; dirp++) {
 			snprintf(pathname, sizeof(pathname), "%s/%s",
-				dirp->name, filename);
-			if (stat(pathname, &stbuf) == 0 &&
-			    (stbuf.st_mode & S_IFMT) == S_IFREG) {
-				if (mode == RRQ) {
-					if ((stbuf.st_mode & S_IROTH) != 0)
-						break;
-				} else {
-					if (!check_woth || ((stbuf.st_mode & S_IWOTH) != 0))
-						break;
-				}
-				err = EACCESS;
+			    dirp->name, filename);
+			if (stat(pathname, &sb) != 0)
+				continue;
+			if (!S_ISREG(sb.st_mode))
+				continue;
+			err = EACCESS;
+			if (mode == RRQ) {
+				if ((sb.st_mode & S_IROTH) == 0)
+					continue;
+			} else {
+				if (check_woth && (sb.st_mode & S_IWOTH) == 0)
+					continue;
 			}
+			break;
 		}
 		if (dirp->name != NULL)
 			*filep = filename = pathname;
@@ -778,27 +769,27 @@ validate_access(int peer, char **filep, int mode)
 	 * This option is handled here because it (might) require(s) the
 	 * size of the file.
 	 */
-	option_tsize(peer, NULL, mode, &stbuf);
+	option_tsize(peer, NULL, mode, &sb);
 
-	if (mode == RRQ)
+	if (mode == RRQ) {
 		fd = open(filename, O_RDONLY);
-	else {
-		if (create_new) {
-			if (increase_name) {
-				error = find_next_name(filename, &fd);
-				if (error > 0)
-					return (error + 100);
-			} else
-				fd = open(filename,
-				    O_WRONLY | O_TRUNC | O_CREAT,
-				    S_IRUSR | S_IWUSR | S_IRGRP |
-				    S_IWGRP | S_IROTH | S_IWOTH );
-		} else
-			fd = open(filename, O_WRONLY | O_TRUNC);
+	} else if (create_new) {
+		if (increase_name) {
+			err = find_next_name(filename, &fd);
+			if (err > 0)
+				return (err + 100);
+		} else {
+			fd = open(filename,
+			    O_WRONLY | O_TRUNC | O_CREAT,
+			    S_IRUSR | S_IWUSR | S_IRGRP |
+			    S_IWGRP | S_IROTH | S_IWOTH );
+		}
+	} else {
+		fd = open(filename, O_WRONLY | O_TRUNC);
 	}
 	if (fd < 0)
 		return (errno + 100);
-	file = fdopen(fd, (mode == RRQ)? "r":"w");
+	file = fdopen(fd, mode == RRQ ? "r" : "w");
 	if (file == NULL) {
 		close(fd);
 		return (errno + 100);
diff --git a/release/Makefile b/release/Makefile
index ba9499ac5a3f..32e59a1a5c90 100644
--- a/release/Makefile
+++ b/release/Makefile
@@ -14,6 +14,7 @@
 #  install: Invokes the release-install and vm-install targets
 #  release-install: Copies all release installation media into ${DESTDIR}
 #  vm-install: Copies all virtual machine images into ${DESTDIR}
+#  cloud-install: Copies non-uploaded cloud images into ${DESTDIR}
 #
 # Variables affecting the build process:
 #  WORLDDIR: location of src tree -- must have built world and default kernel
@@ -329,7 +330,7 @@ real-release:
 	${MAKE} -C ${.CURDIR} ${.MAKEFLAGS} obj
 	${MAKE} -C ${.CURDIR} ${.MAKEFLAGS} ${RELEASE_TARGETS}
 
-install:	release-install vm-install
+install:	release-install vm-install .WAIT cloud-install
 
 release-install:
 .if defined(DESTDIR) && !empty(DESTDIR)
